// RealThumbTestView.cpp : implementation of the CRealThumbTestView class
//

#include "stdafx.h"
#include "RealThumbTest.h"

#include "RealThumbTestDoc.h"
#include "RealThumbTestView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CRealThumbTestView

IMPLEMENT_DYNCREATE(CRealThumbTestView, CView)

BEGIN_MESSAGE_MAP(CRealThumbTestView, CView)
END_MESSAGE_MAP()

// CRealThumbTestView construction/destruction

CRealThumbTestView::CRealThumbTestView()
{
	// TODO: add construction code here

}

CRealThumbTestView::~CRealThumbTestView()
{
}

BOOL CRealThumbTestView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CRealThumbTestView drawing

void CRealThumbTestView::OnDraw(CDC* pDC)
{
	CRealThumbTestDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	WCHAR tmpPath[_MAX_PATH];
	DWORD tmpFlags = 0;
	DWORD tmpPriority = 0;
	CBitmap tmpBmp;
	CComQIPtr<IPersistFile> tmpPersistFile(theApp.m_RealThumb);
	CComQIPtr<IExtractImage> tmpExtractImage(theApp.m_RealThumb);
	HRESULT tmpResult;
	CString msg = "";
	CString tmpSizeStr = "";
	RECT rectSizeDest = {50, 50, 1000, 1000};

	SIZE tmpSize = { 200, 200 };
	// TODO: add draw code for native data here
	theApp.m_CritSect.Lock();
	CA2W tmpString(pDoc->GetPathName());

	tmpResult = tmpPersistFile->Load(tmpString, STGM_READ);
	if (tmpResult != S_OK)
	{
		msg = "Bad file name! ";
		goto drawCleanup;
	}

	tmpResult = tmpExtractImage->GetLocation(reinterpret_cast<LPWSTR>(&tmpPath), 256, &tmpPriority, &tmpSize, pDC->GetDeviceCaps(BITSPIXEL), &tmpFlags);
	if (tmpResult != S_OK)
	{
		msg = "Error Get Location! ";
		goto drawCleanup;
	}

	tmpResult = tmpExtractImage->Extract(reinterpret_cast<HBITMAP*>(&tmpBmp.m_hObject));
	if (tmpResult != S_OK)
	{
		msg = "Error Extract! ";
		goto drawCleanup;
	}
	theApp.m_CritSect.Unlock();

/*
	OpenClipboard();
	EmptyClipboard();
	SetClipboardData(CF_BITMAP, tmpBmp);
	CloseClipboard();
*/
	CDC* tmpDC = new CDC;
	tmpDC->CreateCompatibleDC(pDC);
	CGdiObject* tmpObj = tmpDC->SelectObject(&tmpBmp);
	tmpSizeStr.AppendFormat("%d x %d", tmpSize.cx, tmpSize.cy);
	pDC->DrawText(tmpSizeStr, &rectSizeDest, DT_TOP | DT_LEFT);

	pDC->BitBlt(0, 0, tmpSize.cx, tmpSize.cy, tmpDC, 0, 0, SRCCOPY);
	delete tmpDC;
	pDC->SelectObject(tmpObj);
	DeleteObject(tmpBmp);

drawCleanup:
	if (tmpResult != S_OK) // HACK! HACK! Need more reliable indicator of failure
	{
		theApp.m_CritSect.Unlock();
	}

	RECT rectDest = {0,0,1000,1000};
	pDC->DrawText(msg + pDoc->GetPathName(), &rectDest, DT_TOP | DT_LEFT);
}


// CRealThumbTestView diagnostics

#ifdef _DEBUG
void CRealThumbTestView::AssertValid() const
{
	CView::AssertValid();
}

void CRealThumbTestView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CRealThumbTestDoc* CRealThumbTestView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CRealThumbTestDoc)));
	return (CRealThumbTestDoc*)m_pDocument;
}
#endif //_DEBUG


// CRealThumbTestView message handlers
